#include <bits/stdc++.h>
using namespace std;

int main(int argc, char** argv) {
	int n,k;
	cin>>n;
	cin>>k;
	int A[n];
	int zbir=0;
	int x;
	x=pow(10,9)+7;
	for(int i=0;i<n;i++)
	{
		cin>>A[i];
		zbir+=A[i];
	}
	if(k==0)
	{
		cout<<zbir%x;
	}
	else {
		zbir=0;
		for(int i=0;i<n;i++)
		{
			zbir+=(i+1)*A[i]*(n-i);
			
		}
		cout<<zbir%x;
	}
	return 0;
}